
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class DealsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const deals = await db.deals.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        deal_type: data.deal_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
        probability: data.probability
        ||
        null
            ,
            
        expected_close_at: data.expected_close_at
        ||
        null
            ,
            
        closed_at: data.closed_at
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await deals.setCompany( data.company || null, {
            transaction,
        });
        
        await deals.setPrimary_contact( data.primary_contact || null, {
            transaction,
        });
        
        await deals.setOwner( data.owner || null, {
            transaction,
        });
        
        await deals.setPipeline( data.pipeline || null, {
            transaction,
        });
        
        await deals.setStage( data.stage || null, {
            transaction,
        });
        
        await deals.setLead( data.lead || null, {
            transaction,
        });
        
        await deals.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return deals;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const dealsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                deal_type: item.deal_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
                probability: item.probability
            ||
            null
            ,
            
                expected_close_at: item.expected_close_at
            ||
            null
            ,
            
                closed_at: item.closed_at
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const deals = await db.deals.bulkCreate(dealsData, { transaction });

        // For each item created, replace relation files
        

        return deals;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const deals = await db.deals.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.deal_type !== undefined) updatePayload.deal_type = data.deal_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        if (data.probability !== undefined) updatePayload.probability = data.probability;
        
        
        if (data.expected_close_at !== undefined) updatePayload.expected_close_at = data.expected_close_at;
        
        
        if (data.closed_at !== undefined) updatePayload.closed_at = data.closed_at;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await deals.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await deals.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.primary_contact !== undefined) {
            await deals.setPrimary_contact(
              
              data.primary_contact,
              
              { transaction }
            );
        }
        
        if (data.owner !== undefined) {
            await deals.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        
        if (data.pipeline !== undefined) {
            await deals.setPipeline(
              
              data.pipeline,
              
              { transaction }
            );
        }
        
        if (data.stage !== undefined) {
            await deals.setStage(
              
              data.stage,
              
              { transaction }
            );
        }
        
        if (data.lead !== undefined) {
            await deals.setLead(
              
              data.lead,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await deals.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return deals;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const deals = await db.deals.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of deals) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of deals) {
                await record.destroy({transaction});
            }
        });


        return deals;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const deals = await db.deals.findByPk(id, options);

        await deals.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await deals.destroy({
            transaction
        });

        return deals;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const deals = await db.deals.findOne(
            { where },
            { transaction },
        );

        if (!deals) {
            return deals;
        }

        const output = deals.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        output.activities_deal = await deals.getActivities_deal({
            transaction
        });
        
        
        
        
        
        
        output.production_orders_deal = await deals.getProduction_orders_deal({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.company = await deals.getCompany({
            transaction
        });
        
        
        output.primary_contact = await deals.getPrimary_contact({
            transaction
        });
        
        
        output.owner = await deals.getOwner({
            transaction
        });
        
        
        output.pipeline = await deals.getPipeline({
            transaction
        });
        
        
        output.stage = await deals.getStage({
            transaction
        });
        
        
        output.lead = await deals.getLead({
            transaction
        });
        
        
        output.organizations = await deals.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
        where: filter.company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.company.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.contacts,
        as: 'primary_contact',
        
        where: filter.primary_contact ? {
          [Op.or]: [
            { id: { [Op.in]: filter.primary_contact.split('|').map(term => Utils.uuid(term)) } },
            {
              first_name: {
                [Op.or]: filter.primary_contact.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.pipelines,
        as: 'pipeline',
        
        where: filter.pipeline ? {
          [Op.or]: [
            { id: { [Op.in]: filter.pipeline.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.pipeline.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.pipeline_stages,
        as: 'stage',
        
        where: filter.stage ? {
          [Op.or]: [
            { id: { [Op.in]: filter.stage.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.stage.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.leads,
        as: 'lead',
        
        where: filter.lead ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lead.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.lead.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'deals',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'deals',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.probabilityRange) {
                const [start, end] = filter.probabilityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    probability: {
                    ...where.probability,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    probability: {
                    ...where.probability,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expected_close_atRange) {
                const [start, end] = filter.expected_close_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expected_close_at: {
                    ...where.expected_close_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expected_close_at: {
                    ...where.expected_close_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.closed_atRange) {
                const [start, end] = filter.closed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    closed_at: {
                    ...where.closed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    closed_at: {
                    ...where.closed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.deal_type) {
                where = {
                    ...where,
                deal_type: filter.deal_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.deals.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'deals',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.deals.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

